num_rects = 10000000

$width = 1.0/num_rects

sum = 0.0
r1 = 0...num_rects
r2 = 1..num_rects-1

def calculate_height(i)
  Thread.current[:mid] = (i + 0.5) * $width
  Thread.current[:height] =
    4.0/(1.0 + Thread.current[:mid] * Thread.current[:mid])
end

threads = []
threads << Thread.new {
  Thread.current[:sum] = 0.0
  r1.step(2) { |i|
    calculate_height(i)
    Thread.current[:sum] += Thread.current[:height]
  }
}

threads << Thread.new {
  Thread.current[:sum] = 0.0
  r2.step(2) { |i|
    calculate_height(i)
    Thread.current[:sum] += Thread.current[:height]
  }
}

threads.each { |t| t.join }

sum = 0

threads.each { |t| sum += t[:sum] }

area = $width * sum

puts "Computed pi = #{area}"
